
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Numbering_profilesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const numbering_profiles = await db.numbering_profiles.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        prefix: data.prefix
        ||
        null
            ,
            
        next_number: data.next_number
        ||
        null
            ,
            
        padding: data.padding
        ||
        null
            ,
            
        reset_policy: data.reset_policy
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await numbering_profiles.setBusiness( data.business || null, {
            transaction,
        });
        

        

        

        return numbering_profiles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const numbering_profilesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                prefix: item.prefix
            ||
            null
            ,
            
                next_number: item.next_number
            ||
            null
            ,
            
                padding: item.padding
            ||
            null
            ,
            
                reset_policy: item.reset_policy
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const numbering_profiles = await db.numbering_profiles.bulkCreate(numbering_profilesData, { transaction });

        // For each item created, replace relation files
        

        return numbering_profiles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const numbering_profiles = await db.numbering_profiles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.prefix !== undefined) updatePayload.prefix = data.prefix;
        
        
        if (data.next_number !== undefined) updatePayload.next_number = data.next_number;
        
        
        if (data.padding !== undefined) updatePayload.padding = data.padding;
        
        
        if (data.reset_policy !== undefined) updatePayload.reset_policy = data.reset_policy;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await numbering_profiles.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await numbering_profiles.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        

        
        

        

        return numbering_profiles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const numbering_profiles = await db.numbering_profiles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of numbering_profiles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of numbering_profiles) {
                await record.destroy({transaction});
            }
        });


        return numbering_profiles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const numbering_profiles = await db.numbering_profiles.findByPk(id, options);

        await numbering_profiles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await numbering_profiles.destroy({
            transaction
        });

        return numbering_profiles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const numbering_profiles = await db.numbering_profiles.findOne(
            { where },
            { transaction },
        );

        if (!numbering_profiles) {
            return numbering_profiles;
        }

        const output = numbering_profiles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.journal_voucher_types_numbering_profile = await numbering_profiles.getJournal_voucher_types_numbering_profile({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await numbering_profiles.getBusiness({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'numbering_profiles',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'numbering_profiles',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.prefix) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'numbering_profiles',
                        'prefix',
                        filter.prefix,
                    ),
                };
            }
            

            
            

            
            if (filter.next_numberRange) {
                const [start, end] = filter.next_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    next_number: {
                    ...where.next_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    next_number: {
                    ...where.next_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.paddingRange) {
                const [start, end] = filter.paddingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    padding: {
                    ...where.padding,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    padding: {
                    ...where.padding,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.reset_policy) {
                where = {
                    ...where,
                reset_policy: filter.reset_policy,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.numbering_profiles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'numbering_profiles',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.numbering_profiles.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

